main.hh File Reference
`#include <stdexcept>`
`#include <iostream>`
`#include <cstdlib>`
`#include <mia/core/msgstream.hh>`
Include dependency graph for main.hh:
This graph shows which files directly or indirectly include this file:

Go to the source code of this file.

## Macros

#define | MIA_MAIN(callback)

## Macro Definition Documentation

## MIA_MAIN

#define MIA_MAIN | ( |  | callback | ) |

Value:
int main( int argc, char *argv[] ) \
{ \
try { \
auto verb = getenv("MIA_INITIAL_VERBOSITY"); \
if (verb) { \
auto level = mia::g_verbose_dict.get_value(verb); \
mia::vstream::instance().set_verbosity(level); \
} \
return callback(argc, argv); \
} \
catch (const std::runtime_error &e){ \
std::cerr << "\n" << argv[0] << " runtime error: " << e.what() << std::endl; \
} \
catch (const std::invalid_argument &e){ \
std::cerr << "\n" << argv[0] << " invalid argument: " << e.what() << std::endl; \
} \
catch (const std::logic_error &e){ \
std::cerr << "\n" << argv[0] << " logic error: " << e.what() << std::endl; \
} \
catch (const std::exception& e){ \
std::cerr << "\n" << argv[0] << " error: " << e.what() << std::endl; \
} \
catch (...){ \
std::cerr << "\n" << argv[0] << " unknown exception" << std::endl; \
} \
return EXIT_FAILURE; \
}

Definition at line 27 of file main.hh.